//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

IncludeScript(vscript_dir+"/survivors/single_class/engineer_sentry.nut");
IncludeScript(vscript_dir+"/survivors/single_class/heavy.nut");

//IncludeScript(vscript_dir+"/survivors/survivor_changes/all_class/last_mann_standing.nut");
IncludeScript(vscript_dir+"/survivors/all_class/melee_crits.nut");
IncludeScript(vscript_dir+"/survivors/all_class/melee_wall_climb.nut");

function TrySpawnAsSurvivor(player)
{
    if (!IsSurvivor(player) || survivors.len() == 0)
        return;

    if (player.GetTeam() != GetSurvivorsTeam())
    {
        player.SwitchTeam(GetSurvivorsTeam());
        player.ForceRegenerateAndRespawn();
    }

    player.SetCustomModelWithClassAnimations("")
    SetPropInt(player, "m_bForcedSkin", 0);
}
AddListener("spawn", TrySpawnAsSurvivor, 0);

function TeamChangeHandler(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    if (IsZombie(player) && params.team != GetZombiesTeam())
        RunWithDelay("SwitchPlayerTeam(activator, GetZombiesTeam())", player, 0);
    if (IsSurvivor(player) && params.team != GetSurvivorsTeam())
        RunWithDelay("SwitchPlayerTeam(activator, GetSurvivorsTeam())", player, 0);
}
AddListener("team_change", TeamChangeHandler, 0);

function SurvivorDeath(params)
{
    if (!infection || IsRoundSetup())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    if (IsSurvivor(player))
        AssignToZombies(player);
}
AddListener("death", SurvivorDeath, 0);

function AssignToZombies(player)
{
    local index = survivors.find(player);
    if (index != null)
    {
        survivors.remove(index);
        player.SwitchTeam(GetZombiesTeam());
    }
    if (survivors.len() == 0)
        EndRound(GetZombiesTeam());
}